regina::NXMLDim2TriangulationReader Class Reference
2-Manifold Triangulations

An XML packet reader that reads a single 2-manifold triangulation. More...

`#include <dim2/nxmldim2trireader.h>`

Inheritance diagram for regina::NXMLDim2TriangulationReader:

## Public Member Functions

| NXMLDim2TriangulationReader (NXMLTreeResolver &resolver)
| Creates a new triangulation reader. More...
virtual NPacket * | getPacket ()
| Returns the newly allocated packet that has been read by this element reader. More...
virtual NXMLElementReader * | startContentSubElement (const std::string &subTagName, const regina::xml::XMLPropertyDict &subTagProps)
| Used instead of startSubElement() for XML subelements that are not child packets or packet tags. More...
virtual void | endContentSubElement (const std::string &subTagName, NXMLElementReader *subReader)
| Used instead of endSubElement() for XML subelements that are not child packets or packet tags. More...
virtual NXMLElementReader * | startSubElement (const std::string &subTagName, const regina::xml::XMLPropertyDict &subTagProps)
| Signifies that a subelement of this XML element is about to be parsed. More...
virtual void | endSubElement (const std::string &subTagName, NXMLElementReader *subReader)
| Signifies that parsing has finished for a subelement of this XML element. More...
virtual void | abort (NXMLElementReader *subReader)
| Signifies that XML parsing has been aborted. More...
virtual void | startElement (const std::string &tagName, const regina::xml::XMLPropertyDict &tagProps, NXMLElementReader *parentReader)
| Signifies that parsing of this XML element is beginning. More...
virtual void | initialChars (const std::string &chars)
| Signifies that the initial text belonging to this XML element has been read. More...
virtual void | endElement ()
| Signifies that parsing of this XML element is finished. More...
virtual void | usingParser (regina::xml::XMLParser *parser)
| Called for the top-level element in an XML file when parsing begins. More...

## Protected Attributes

NXMLTreeResolver & | resolver_
| The master resolver that will be used to fix dangling packet references after the entire XML file has been read. More...

## Detailed Description

An XML packet reader that reads a single 2-manifold triangulation.

Python:
  Not present.

## Constructor & Destructor Documentation

regina::NXMLDim2TriangulationReader::NXMLDim2TriangulationReader | ( | NXMLTreeResolver & | resolver | ) |

inline

Creates a new triangulation reader.

Parameters

  resolver | the master resolver that will be used to fix dangling packet references after the entire XML file has been read.

## Member Function Documentation

virtual void regina::NXMLPacketReader::abort | ( | NXMLElementReader * | subReader | ) |

virtual inherited

Signifies that XML parsing has been aborted.

This element reader will be destroyed shortly after this routine is called.

The default implementation does nothing.

Parameters

  subReader | the corresponding child reader if a subelement is currently being parsed, or 0 otherwise. If this parameter is non-zero, it is guaranteed that abort() has already been called upon the child reader and that the child reader has not yet been destroyed.

Reimplemented from regina::NXMLElementReader.

virtual void regina::NXMLDim2TriangulationReader::endContentSubElement | ( | const std::string & | subTagName,
|  | NXMLElementReader * | subReader
| ) |  |

virtual

Used instead of endSubElement() for XML subelements that are not child packets or packet tags.

The default implementation does nothing.

Parameters

  subTagName | the name of the subelement closing tag.
  subReader | the child reader that was used to parse the subelement (this is the reader that was returned by the corresponding startContentSubElement() call). It is guaranteed that endElement() has already been called upon this child reader and that the child reader has not yet been destroyed.

Reimplemented from regina::NXMLPacketReader.

void regina::NXMLElementReader::endElement | ( |  | ) |

inline virtual inherited

Signifies that parsing of this XML element is finished.

It is guaranteed that endSubElement() has not yet been called upon the parent reader (if one exists).

The default implementation does nothing.

virtual void regina::NXMLPacketReader::endSubElement | ( | const std::string & | subTagName,
|  | NXMLElementReader * | subReader
| ) |  |

virtual inherited

Signifies that parsing has finished for a subelement of this XML element.

The default implementation does nothing.

Parameters

  subTagName | the name of the subelement closing tag.
  subReader | the child reader that was used to parse the subelement (this is the reader that was returned by the corresponding startSubElement() call). It is guaranteed that endElement() has already been called upon this child reader and that the child reader has not yet been destroyed.

Reimplemented from regina::NXMLElementReader.

NPacket * regina::NXMLDim2TriangulationReader::getPacket | ( |  | ) |

inline virtual

Returns the newly allocated packet that has been read by this element reader.

Deallocation of this new packet is not the responsibility of this class. Once this routine gives a non-zero return value, it should continue to give the same non-zero return value from this point onwards.

If this routine is ever to give a non-zero return value, it must be giving that non-zero return value by the time the first child packet or packet tag is encountered; otherwise child packets will not be inserted into the packet tree and/or packet tags will not be added.

The newly allocated packet should not be given a packet label. This will be done by NXMLPacketReader::endSubElement().

The newly allocated packet may or may not be inserted in the packet tree structure; this does not matter (although if it is inserted it must be inserted in the correct place).

The newly allocated packet should not be given any associated packet tags. This will be done by NXMLPacketReader::startSubElement().

The default implementation returns 0.

Returns
  the packet that has been read, or 0 if packet reading is incomplete, the packet should be ignored or an error occurred.

Reimplemented from regina::NXMLPacketReader.

void regina::NXMLElementReader::initialChars | ( | const std::string & | chars | ) |

inline virtual inherited

Signifies that the initial text belonging to this XML element has been read.

The initial text is everything between the opening tag and the first subelement or closing tag.

The default implementation does nothing.

Parameters

  chars | the initial text for this element.

Reimplemented in regina::NXMLCharsReader, regina::NXMLNormalSurfaceReader, regina::NXMLAngleStructureReader, and regina::NXMLAbelianGroupReader.

virtual NXMLElementReader* regina::NXMLDim2TriangulationReader::startContentSubElement | ( | const std::string & | subTagName,
|  | const regina::xml::XMLPropertyDict & | subTagProps
| ) |  |

virtual

Used instead of startSubElement() for XML subelements that are not child packets or packet tags.

The default implementation returns a new NXMLElementReader which can be used to ignore the subelement completely.

Parameters

  subTagName | the name of the subelement opening tag.
  subTagProps | the properties associated with the subelement opening tag.

Returns
  a newly created element reader that will be used to parse the subelement. This class should not take care of the new reader's destruction; that will be done by the parser.

Reimplemented from regina::NXMLPacketReader.

void regina::NXMLElementReader::startElement | ( | const std::string & | tagName,
|  | const regina::xml::XMLPropertyDict & | tagProps,
|  | NXMLElementReader * | parentReader
| ) |  |

inline virtual inherited

Signifies that parsing of this XML element is beginning.

The default implementation does nothing.

Parameters

  tagName | the name of the opening tag for this element.
  tagProps | the properties associated with the opening tag.
  parentReader | the reader currently parsing the parent XML element, or 0 if this is the top-level element. If this paraneter is non-zero, it is guaranteed that startSubElement() has already been called upon the parent reader.

Reimplemented in regina::NXMLGroupPresentationReader, regina::NXMLNormalSurfaceReader, regina::NXMLAngleStructureReader, and regina::NXMLAbelianGroupReader.

virtual NXMLElementReader* regina::NXMLPacketReader::startSubElement | ( | const std::string & | subTagName,
|  | const regina::xml::XMLPropertyDict & | subTagProps
| ) |  |

virtual inherited

Signifies that a subelement of this XML element is about to be parsed.

The default implementation returns a new NXMLElementReader which can be used to ignore the subelement completely.

Parameters

  subTagName | the name of the subelement opening tag.
  subTagProps | the properties associated with the subelement opening tag.

Returns
  a newly created element reader that will be used to parse the subelement. This class should not take care of the new reader's destruction; that will be done by the parser.

Reimplemented from regina::NXMLElementReader.

void regina::NXMLElementReader::usingParser | ( | regina::xml::XMLParser * | parser | ) |

inline virtual inherited

Called for the top-level element in an XML file when parsing begins.

This allows direct access to the parser if needed (for instance, to change the character encoding).

The default implementation does nothing.

Parameters

  parser | the current XML parser.

## Member Data Documentation

NXMLTreeResolver& regina::NXMLPacketReader::resolver_

protected inherited

The master resolver that will be used to fix dangling packet references after the entire XML file has been read.

The documentation for this class was generated from the following file:

- dim2/nxmldim2trireader.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).